﻿-----------------------------------------------------------------------
-- Locale
-----------------------------------------------------------------------
local L = AceLibrary("AceLocale-2.2"):new("Violation: Decurse")

L:RegisterTranslations("enUS", function() return {
	["Decursing done"] = true,
	["Decursing"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Decursing done"] = "해제 횟수",
	["Decursing"] = "해제",
} end)

-----------------------------------------------------------------------
-- Locals
-----------------------------------------------------------------------

local moduleName = "Decursing done"
local parserEvent = {
	eventType = "Dispel",
	sourceID_not = false,
	recipientID_not = false,
}

-----------------------------------------------------------------------
-- Module declaration
-----------------------------------------------------------------------

local mod = Violation:NewModule(moduleName)
mod.revision = tonumber(("$Revision: 45870 $"):sub(12, -3)) or 1
mod.version = 5
mod.violationCategory = "other"

-----------------------------------------------------------------------
-- Module initialization
-----------------------------------------------------------------------

function mod:OnModuleEnable()
	self:RegisterParserEvent( parserEvent, "OnParserEvent" )
end

-----------------------------------------------------------------------
-- Module implementation
-----------------------------------------------------------------------

function mod:GetDisplayName() return L["Decursing done"] end
function mod:GetShortDisplayName() return L["Decursing"] end

function mod:OnParserEvent( info )
	if info.isFailed then return end
	local source = self:GetSourceVictimAmount(info)

	if not source or not self:AcceptDataFor( source ) then
		return
	end

	self:OnData(source, 1)
end
